// transform where construct to where statement 
#include        <stdio.h>
#include        <malloc.h>
#include        <string.h>
#include        "compilerApi.h"
#include        "ext_func.h"
#define 	IDSTR	"A"
int     whereconstruct_to_where(SgStatement *,SgStatement *);
 //change the where construct to where statement

SgVariableSymb  *get_temp_variable(SgStatement *,SgType *,char *);
//return a temporary variable and declare it in given statement

SgVariableSymb	*get_temp_index(int,SgStatement *,char *);
//return an index variable and declare it in given statement
//int variable is the digit used in the index variable. 

void	init_temp_index(SgStatement *);
//initialize index variable

int	isBinaryOp(SgExpression *);
//judge if given expression have left hand and right hand

int is_function(SgExpression *);
//if the expression is any form of function call or function reference or user defined operator 

int 	if_trans(SgStatement *);
//if we need to change the statement

SgType * array_exp_type(SgExpression * exp);
// get the exp's type .

#include "consw.h"

int     whereconstruct_to_where(SgStatement *hedr_stmt,SgStatement *current)
{
        SgAssignStmt    *aassign;
	SgStatement	*statement,*next_stmt,*temp_stmt,*control_parent;
	SgWhereStmt	*awherestmt;
        SgVarRefExp     *index_exp;
        SgExpression    *index_trip;
        SgVariableSymb  *temp;
        SgExpression    *lhs_res,*rhs_res,*mask_res;
        SgExpression    *lhs,*rhs,*cond;
	int		index_var=0;
	SgSubscriptExp	*subscript;
	SgType		*returntype;
	SgType		type(T_BOOL);
	SgStatement	*decl_stmt,*last_decl;
        SgVariableSymb  *var_sym;
	int 		i=0;
	SgVarRefExp	*var_sym_exp;
	SgExpression	*false_exp,*temp_mask_exp;
//get the control parent statement.
	control_parent=current->controlParent();
//get mask_expr of the where statement
        cond=current->expr(0);
//get the left Hand side of assign statement
        lhs=(current->childList1(0))->expr(0);
//get array type of given expression
	returntype=array_exp_type(lhs);
	((SgArrayType*)returntype)->setBaseType(type);
//get temporary variable of given type
        var_sym=get_temp_variable(hedr_stmt,returntype,IDSTR);
	var_sym_exp=new SgVarRefExp(var_sym);
	temp_mask_exp=var_sym_exp;
// make the stmt
        decl_stmt=var_sym->makeVarDeclStmt();
//get last declare statement
        last_decl=hedr_stmt->lastDeclaration();
//declare the symbol
        last_decl->insertStmtAfter(*decl_stmt,*hedr_stmt);
//create mask expr assign  statement
        aassign= new  SgAssignStmt(*temp_mask_exp,*cond->copyPtr());
//insert the mask assign statement
//        current->lexPrev()->insertStmtAfter(*aassign,*control_parent);
        current->insertStmtBefore(*aassign,*control_parent);

//now split the where construct to where statement
//first split the true block
	statement=current->childList1(i++);
	while ( (statement!=NULL) && (statement->variant() != CONTROL_END)){
                temp_stmt=statement->copyPtr();
		awherestmt=new SgWhereStmt(*temp_mask_exp,*temp_stmt);
	        current->insertStmtBefore(*awherestmt,*control_parent);
                //current->lexPrev()->insertStmtAfter(*awherestmt,*control_parent);

		statement=current->childList1(i++);
                //statement=current->nextInChildList();
                //statement=statement->lexNext();

                var_sym_exp=new SgVarRefExp(var_sym);
                temp_mask_exp=var_sym_exp;

	}

//now split the FALSE block
	i=0;
	//false_exp=&((*temp_mask_exp) ^= (*temp_mask_exp));
        false_exp=&(SgNotOp(*temp_mask_exp));
	statement=current->childList2(i++);
        while ( (statement!=NULL) && (statement->variant() != CONTROL_END) ){
                temp_stmt=statement->copyPtr();
		//statement=statement->copyPtr();
                awherestmt=new SgWhereStmt(*false_exp,*temp_stmt);
                current->insertStmtBefore(*awherestmt,*control_parent);

 //               current->lexPrev()->insertStmtAfter(*awherestmt,*control_parent);

                statement=current->childList2(i++);  
                //statement=current->nextInChildList();
	        var_sym_exp=new SgVarRefExp(var_sym);
	       	temp_mask_exp=var_sym_exp;
		false_exp=&(SgNotOp(*temp_mask_exp));

	
        }


//delete the original where construct
        current->deleteStmt();
        return  0;

}
