
void check_1(requirement,p,lx,ly,ux,uy,l,u,s,d1,d2,ax,ay,a1,a2,
           ltx,utx,lty,uty,bx,by,b1,b2)
   int requirement, p,lx,ly,ux,uy,l,u,s,d1,d2;
   int ax,ay,a1,a2,ltx,utx,lty,uty,bx,by,b1,b2; {

   switch (requirement) {
      case 1:
         if (!(lx <= l && l < u && u <= ux)) 
           printf ("problem with array-bound condition: lx,l,u,ux %d %d %d %d \n", lx,l,u,ux);
         if (!(ly <= a1*l+b1 && a1*l < a1*u && a1*u+b1 <= uy)) 
           printf ("problem with array-bound condition: ly,a1,b1,l,u,uy %d %d %d %d %d %d\n", ly,a1,b1,l,u,uy);
         if (!(ltx <= ax*lx+bx && ax*ux+bx <= utx)) 
           printf ("problem with template-bound condition: ltx,ax,lx,bx,ux,utx %d %d %d %d %d %d\n", ltx,ax,lx,bx,ux,utx);
         if (!(lty <= ay*ly+by && ay*uy+by <= uty))
           printf ("problem with template-bound condition: lty,ay,ly,by,uy,uty %d %d %d %d %d %d\n", lty,ay,ly,by,uy,uty);
         break;
      case 2:
         if (!(lx <= l && l < u && u <= ux)) 
           printf ("problem with array-bound condition: lx,l,u,ux %d %d %d %d \n", lx,l,u,ux);
         if (!(ly <= a1*l+b1 && a1*l < a1*u && a1*u+b1 <= uy)) 
           printf ("problem with array-bound condition: ly,a1,b1,l,u,uy %d %d %d %d %d %d\n", ly,a1,b1,l,u,uy);
         if (!(ly <= a1*l+b2 && a1*l < a1*u && a1*u+b2 <= uy)) 
           printf ("problem with array-bound condition: ly,a1,b2,l,u,uy %d %d %d %d %d %d\n", ly,a1,b2,l,u,uy);
         if (!(ltx <= ax*lx+bx && ax*ux+bx <= utx)) 
           printf ("problem with template-bound condition: ltx,ax,lx,bx,ux,utx %d %d %d %d %d %d\n", ltx,ax,lx,bx,ux,utx);
         if (!(lty <= ay*ly+by && ay*uy+by <= uty))
           printf ("problem with template-bound condition: lty,ay,ly,by,uy,uty %d %d %d %d %d %d\n", lty,ay,ly,by,uy,uty);
         break;
      case 3:
         if (!(lx <= l && l < u && u <= ux)) 
           printf ("problem with array-bound condition: lx,l,u,ux %d %d %d %d \n", lx,l,u,ux);
         if (!(ly <= a1*l+b1 && a1*l < a1*u && a1*u+b1 <= uy)) 
           printf ("problem with array-bound condition: ly,a1,b1,l,u,uy %d %d %d %d %d %d\n", ly,a1,b1,l,u,uy);
         if (!(ly <= a1*l+b2 && a1*l < a1*u && a1*u+b2 <= uy)) 
           printf ("problem with array-bound condition: ly,a1,b2,l,u,uy %d %d %d %d %d %d\n", ly,a1,b2,l,u,uy);
         if (!(ly <= a2*l+b1 && a2*l < a2*u && a2*u+b1 <= uy)) 
           printf ("problem with array-bound condition: ly,a2,b1,l,u,uy %d %d %d %d %d %d\n", ly,a2,b1,l,u,uy);
         if (!(ly <= a2*l+b2 && a1*l < a2*u && a2*u+b2 <= uy)) 
           printf ("problem with array-bound condition: ly,a2,b2,l,u,uy %d %d %d %d %d %d\n", ly,a2,b2,l,u,uy);
         if (!(ltx <= ax*lx+bx && ax*ux+bx <= utx)) 
           printf ("problem with template-bound condition: ltx,ax,lx,bx,ux,utx %d %d %d %d %d %d\n", ltx,ax,lx,bx,ux,utx);
         if (!(lty <= ay*ly+by && ay*uy+by <= uty))
           printf ("problem with template-bound condition: lty,ay,ly,by,uy,uty %d %d %d %d %d %d\n", lty,ay,ly,by,uy,uty);
         break;
      case 4:
         if (!(lx <= l && l < u && u <= ux)) 
           printf ("problem with array-bound condition: lx,l,u,ux %d %d %d %d \n", lx,l,u,ux);
         if (!(ly <= a1*l+b1 && a1*l < a1*u && a1*u+b1 <= uy)) 
           printf ("problem with array-bound condition: ly,a1,b1,l,u,uy %d %d %d %d %d %d\n", ly,a1,b1,l,u,uy);
         if (!(ly <= a1*l+b2 && a1*l < a1*u && a1*u+b2 <= uy)) 
           printf ("problem with array-bound condition: ly,a1,b2,l,u,uy %d %d %d %d %d %d\n", ly,a1,b2,l,u,uy);
         if (!(ly <= a2*l+b1 && a2*l < a2*u && a2*u+b1 <= uy)) 
           printf ("problem with array-bound condition: ly,a2,b1,l,u,uy %d %d %d %d %d %d\n", ly,a2,b1,l,u,uy);
         if (!(ly <= a2*l+b2 && a2*l < a2*u && a2*u+b2 <= uy)) 
           printf ("problem with array-bound condition: ly,a2,b2,l,u,uy %d %d %d %d %d %d\n", ly,a2,b2,l,u,uy);
         if (!(ltx <= ax*lx+bx && ax*ux+bx <= utx)) 
           printf ("problem with template-bound condition: ltx,ax,lx,bx,ux,utx %d %d %d %d %d %d\n", ltx,ax,lx,bx,ux,utx);
         if (!(lty <= ay*ly+by && ay*uy+by <= uty))
           printf ("problem with template-bound condition: lty,ay,ly,by,uy,uty %d %d %d %d %d %d\n", lty,ay,ly,by,uy,uty);
         break;
      default:
         break;
   }
   return;  
};


void check_2(requirement,p,lx,ly,ux,uy,l,u,s,d1,d2,ax,ay,a1,a2,
             ltx,utx,lty,uty,bx,by,b1,b2,
             xs1l, xs1u, xs1s, ys1l, ys1u, ys1s,
             xs2l, xs2u, xs2s, ys2l, ys2u, ys2s)
   int requirement, p,lx,ly,ux,uy,l,u,s,d1,d2;
   int ax,ay,a1,a2,ltx,utx,lty,uty,bx,by,b1,b2;
   int xs1l,xs1u,xs1s,ys1l,ys1u,ys1s,xs2l,xs2u,xs2s,ys2l,ys2u,ys2s; {

   switch (requirement) {
      case 1:
         if (!(lx <= l && l < u && u <= ux)) 
           printf ("problem with array-bound condition: lx,l,u,ux %d %d %d %d \n", lx,l,u,ux);
         if (!(ly <= a1*l+b1 && a1*l < a1*u && a1*u+b1 <= uy)) 
           printf ("problem with array-bound condition: ly,a1,b1,l,u,uy %d %d %d %d %d %d\n", ly,a1,b1,l,u,uy);
         if (!(ltx <= ax*lx+bx && ax*ux+bx <= utx)) 
           printf ("problem with template-bound condition: ltx,ax,lx,bx,ux,utx %d %d %d %d %d %d\n", ltx,ax,lx,bx,ux,utx);
         if (!(lty <= ay*ly+by && ay*uy+by <= uty))
           printf ("problem with template-bound condition: lty,ay,ly,by,uy,uty %d %d %d %d %d %d\n", lty,ay,ly,by,uy,uty);

         break;
      case 2:
         if (!(lx <= l && l < u && u <= ux)) 
           printf ("problem with array-bound condition: lx,l,u,ux %d %d %d %d \n", lx,l,u,ux);
         if (!(ly <= a1*l+b1 && a1*l < a1*u && a1*u+b1 <= uy)) 
           printf ("problem with array-bound condition: ly,a1,b1,l,u,uy %d %d %d %d %d %d\n", ly,a1,b1,l,u,uy);
         if (!(ly <= a1*l+b2 && a1*l < a1*u && a1*u+b2 <= uy)) 
           printf ("problem with array-bound condition: ly,a1,b2,l,u,uy %d %d %d %d %d %d\n", ly,a1,b2,l,u,uy);
         if (!(ltx <= ax*lx+bx && ax*ux+bx <= utx)) 
           printf ("problem with template-bound condition: ltx,ax,lx,bx,ux,utx %d %d %d %d %d %d\n", ltx,ax,lx,bx,ux,utx);
         if (!(lty <= ay*ly+by && ay*uy+by <= uty))
           printf ("problem with template-bound condition: lty,ay,ly,by,uy,uty %d %d %d %d %d %d\n", lty,ay,ly,by,uy,uty);
         break;
      case 3:
         break;
      case 4:
         if (d1 == 2) {
            if (!(s*(a2*ay-ax) % p)) 
               printf(" The second term is not remap !\n");
            if ((s*(a1*ay-ax) % p)) 
               printf(" The first term is not shift !\n");
         } 
         break;
      default:
         break;
   }
   return;  
};

